=== debian/rules ===
--- 
+++ 
@@ -1,11 +1,11 @@
 #!/usr/bin/make -f
-export COMPONENT_HASH=7f07ef8e6df428a8eb53009dc8d9a249dbbb50ad
- HADOOP_VERSION=3.0.0+cdh6.3.0
- HADOOP_PATCHED_VERSION=3.0.0-cdh6.3.0
+export COMPONENT_HASH=9aff20de3b5ecccf3c19d57f71b214fb4d37ee89
+ HADOOP_VERSION=3.0.0+cdh6.3.2
+ HADOOP_PATCHED_VERSION=3.0.0-cdh6.3.2
  HADOOP_BASE_VERSION=3.0.0
- HADOOP_RELEASE=1279813
+ HADOOP_RELEASE=1605554
  CDH_CUSTOMER_PATCH=p0
- CDH_PARCEL_CUSTOM_VERSION=3.0.0+cdh6.3.0-1279813.bionic
+ CDH_PARCEL_CUSTOM_VERSION=3.0.0+cdh6.3.2-1605554.bionic
 
 # Licensed to the Apache Software Foundation (ASF) under one or more
 # contributor license agreements.  See the NOTICE file distributed with
